# PolygonOps

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliageometry.github.io/PolygonOps.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliageometry.github.io/PolygonOps.jl/dev)

The objective of this package is to provide a set of generic polygon operations. There are two assumptions: 
 - the container and points are both vector-like.
 - the first and last elements are equal. 
 
This should provide generic implementations portable and extensible for packages such as GeometryTypes, GeometryBasics, and JuliaGeo.

Please see the [docs](https://juliageometry.github.io/PolygonOps.jl/stable) for a list of exported functions.

Implements:
  - point-in-polygon
  - signed area (shoelace formula)
  - centroid

Planned:
  - simplification
  - booleans (ported from PolygonClipping.jl)
  - offset/insetting

abstract type MembershipCheckAlgorithm end

"""
Algorithm by Hao and Sun (2018):
https://doi.org/10.3390/sym10100477
"""
struct HaoSun <: MembershipCheckAlgorithm end

"""
Hormann-Agathos (2001) Point in Polygon algorithm:
https://doi.org/10.1016/S0925-7721(01)00012-8
"""
struct HormannAgathos <: MembershipCheckAlgorithm end

"""
    inpolygon(p, poly)
    inpolygon(p, poly, [::MembershipCheckAlgorithm])
    inpolygon(p, poly, [::MembershipCheckAlgorithm]; in = 1, on = -1, out = 0)

check the membership of `p` in `poly` where `poly` is an `AbstractVector` of `AbstractVector`s.
`poly` should have the first and last elements equal.

*Returns:*
- in = 1
- on = -1
- out = 0

*MembershipCheckAlgorithm:*

- `HaoSun()`
- `HormannAgathos()`

Default is `HaoSun()` as it has the best performance and works invariant of winding order and self-intersections.
However the HaoSun algorithm is new and bugs may be possible. The classic HormannAgathos algorithm
is provided, however it is sensitive to self-intersections and winding order so may produce different results.

*Custom return values:*

The return logic can be customized to return alternate values and types by specify the `in`, `on`, and `out` keywords.
For example, to treat the 'on' and 'in' cases the same and return a `Bool`:
`inpolygon(p, poly, in=true, on=true, out=false)`

Algorithm by Hao and Sun (2018):
https://doi.org/10.3390/sym10100477

Hormann-Agathos (2001) Point in Polygon algorithm:
https://doi.org/10.1016/S0925-7721(01)00012-8
"""
function inpolygon(p, poly; kwargs...)
    inpolygon(p, poly, HaoSun(); kwargs...)
end

function inpolygon(p, poly, ::Union{HaoSun,Type{HaoSun}}; in::T=1, on::T=-1, out::T=0) where {T}
    k = 0

    xp = p[1]
    yp = p[2]

    validate_poly(poly)

    PT = eltype(p)

    @inbounds for i in UnitRange(firstindex(poly),lastindex(poly)-1)
        v1 = poly[i][2] - yp
        v2 = poly[i+1][2] - yp

        if v1 < zero(PT) && v2 < zero(PT) || v1 > zero(PT) && v2 > zero(PT)
            continue
        end

        u1 = poly[i][1] - xp
        u2 = poly[i+1][1] - xp

        f = (u1 * v2) - (u2 * v1)

        if v2 > zero(PT) && v1 <= zero(PT)
            if f > zero(PT)
                k += 1
            elseif iszero(f)
                return on
            end
        elseif v1 > zero(PT) && v2 <= zero(PT)
            if f < zero(PT)
                k += 1
            elseif iszero(f)
                return on
            end
        elseif iszero(v2) && v1 < zero(PT)
            iszero(f) && return on
        elseif iszero(v1) && v2 < zero(PT)
            iszero(f) && return on
        elseif iszero(v1) && iszero(v2)
            if u2 <= zero(PT) && u1 >= zero(PT)
                return on
            elseif u1 <= zero(PT) && u2 >= zero(PT)
                return on
            end
        end
    end

    iszero(k % 2) && return out
    return in
end

function detq(q1,q2,r)
    @inbounds (q1[1]-r[1])*(q2[2]-r[2])-(q2[1]-r[1])*(q1[2]-r[2])
end


function inpolygon(r, poly, ::Union{HormannAgathos,Type{HormannAgathos}};
                   in::T=1, on::T=-1, out::T=0) where{T}
    c = false

    validate_poly(poly)

    @inbounds for i in UnitRange(firstindex(poly),lastindex(poly)-1)
        q1 = poly[i]
        q2 = poly[i+1]
        if q1 == r
            # throw(VertexException())
            return on
        end
        if q2[2] == r[2]
            if q2[1] == r[1]
                #throw(VertexException())
                return on
            elseif (q1[2] == r[2]) && ((q2[1] > r[1]) == (q1[1] < r[1]))
                #throw(EdgeException())
                return on
            end
        end
        if (q1[2] < r[2]) != (q2[2] < r[2]) # crossing
            if q1[1] >= r[1]
                if q2[1] > r[1]
                    c = !c
                elseif (detq(q1,q2,r) > 0) == (q2[2] > q1[2]) # right crossing
                    c = !c
                end
            elseif q2[1] > r[1]
                if (detq(q1,q2,r) > 0) == (q2[2] > q1[2]) # right crossing
                    c = !c
                end
            end
        end
    end
    return c ? in : out
end

# Data hand processed from https://github.com/dengwirda/inpoly by @miguelraz on 28/03/2020 under terms of fair use.

include("coast.jl")
include("coast-edges.jl")
include("lakes.jl")
include("lakes-edges.jl")
include("river.jl")
include("river-edges.jl")

using BenchmarkTools
using PolygonOps
using StaticArrays
using Test

const suite = BenchmarkGroup()
suite["inpolygon"] = BenchmarkGroup()

circle(t) = SVector(cos(t), sin(t))

circle_poly = map(circle, 0:(2pi/1000000):2pi)

#@show length(circle_poly)

# using Plots
# display(plot(map(x -> x[1], circle_poly),map(x -> x[2], circle_poly)))

# end == begin
push!(circle_poly, circle_poly[1])
for algo in (HaoSun(),HormannAgathos())
    @test inpolygon(SVector(0.1,0),circle_poly,algo) == 1
    @test inpolygon(SVector(0.,2.),circle_poly,algo) == 0
    @test inpolygon(SVector(2.,0.),circle_poly,algo) == 0
    @test inpolygon(SVector(1.,0.),circle_poly,algo) == -1
    @test inpolygon(SVector(0.,-2.),circle_poly,algo) == 0
end

suite["inpolygon"]["circle, HaoSun"] = @benchmarkable inpolygon(SVector(0,0),circle_poly, HaoSun())
suite["inpolygon"]["circle, HormanAgathos"] = @benchmarkable inpolygon(SVector(0,0),circle_poly, HormannAgathos())


results = run(suite)

for trial in results
    ctx = IOContext(stdout, :verbose => true, :compact => false)
    println(ctx)
    println(ctx, trial.first)
    println(ctx, trial.second)
end

using PolygonOps
using Test
using StaticArrays

edge(p1, p2) = (SVector(p1),SVector(p2))

@testset "inpolygon" begin
    poly1 = SVector{2,Int}[(0,0),(0,10),(10,10),(10,0),(0,0)]

    @testset "Hao Sun" begin
        algo = HaoSun()
        for poly in (poly1, reverse(poly1))
            @test inpolygon(SVector(5,5),poly, algo) == 1 #in
            @test inpolygon(SVector(-5,-5),poly, algo) == 0 #out
            @test inpolygon(SVector(0,5),poly, algo) == -1 #on
            @test inpolygon(SVector(5,10),poly, algo) == -1 #on
            @test inpolygon(SVector(10,10),poly, algo) == -1 #on
            @test inpolygon(SVector(0,0),poly, algo) == -1 #on

            @test inpolygon(SVector(5,5),poly, algo, in=true,on=true,out=false) #in
            @test !inpolygon(SVector(-5,-5),poly, algo, in=true,on=true,out=false) #out
            @test inpolygon(SVector(0,5),poly, algo, in=true,on=true,out=false) #on
            @test inpolygon(SVector(5,10),poly, algo, in=true,on=true,out=false) #on
            @test inpolygon(SVector(10,10),poly, algo, in=true,on=true,out=false) #on
            @test inpolygon(SVector(0,0),poly, algo, in=true,on=true,out=false) #on
        end
    end
    @testset "Hormann Agathos" begin
        algo = HormannAgathos()

        poly = reverse(poly1)
        @test inpolygon(SVector(5,5),poly, algo) == 1 #in
        @test inpolygon(SVector(-5,-5),poly, algo) == 0 #out
        #@test_broken inpolygon(SVector(0,5),poly, algo) == -1 #on
        @test inpolygon(SVector(5,10),poly, algo) == -1 #on
        @test inpolygon(SVector(10,10),poly, algo) == -1 #on
        @test inpolygon(SVector(0,0),poly, algo) == -1 #on
    end
    @testset "API" begin
        poly = poly1
        @test inpolygon(SVector(5,5),poly, in=true,on=true,out=false) #in
        @test !inpolygon(SVector(-5,-5),poly, in=true,on=true,out=false) #out
        @test inpolygon(SVector(0,5),poly, in=true,on=true,out=false) #on
        @test inpolygon(SVector(5,10),poly, in=true,on=true,out=false) #on
        @test inpolygon(SVector(10,10),poly, in=true,on=true,out=false) #on
        @test inpolygon(SVector(0,0),poly, in=0x0,on=0x0,out=0x1) === 0x0 #on
    end
end

@testset "area/centroid" begin
    poly1 = SVector{2,Int}[(0,0),(0,10),(10,10),(10,0),(0,0)]
    poly2 = poly1.*5

    @testset "area" begin
        @test PolygonOps.area(poly1) == -100
        @test PolygonOps.area(reverse(poly1)) == 100
        @test PolygonOps.area(poly2) == -2500
        @test PolygonOps.area(reverse(poly2)) == 2500
    end

    @testset "centroid" begin
        @test PolygonOps.centroid(poly1) == SVector(5,5)
        @test PolygonOps.centroid(reverse(poly1)) == SVector(5,5)
        @test PolygonOps.centroid(poly2) == SVector(25,25)
        @test PolygonOps.centroid(reverse(poly2)) == SVector(25,25)
    end
end

using Documenter, PolygonOps

makedocs(;
    modules=[PolygonOps],
    format=Documenter.HTML(),
    pages=[
        "Home" => "index.md",
    ],
    repo="https://github.com/JuliaGeometry/PolygonOps.jl/blob/{commit}{path}#L{line}",
    sitename="PolygonOps.jl",
    authors="steve <kd2cca@gmail.com>")

deploydocs(;
    repo="github.com/JuliaGeometry/PolygonOps.jl",
)

"""
    area(poly)

Calculate the signed area via the shoelace formula. If the points are ordered
counterclockwise, the result will be positive. If the points are ordered clockwise,
the result will be negative.
"""
function area(poly::T) where T
    a = zero(eltype(eltype(T)))
    @inbounds for i in 1:length(poly)-1
        p1 = poly[i]
        p2 = poly[i+1]
        a += p1[1]*p2[2]-p2[1]*p1[2]
    end
    return a/2
end

function centroid(poly::T) where T
    ZT = zero(eltype(eltype(T)))
    a = ZT
    c = zero(eltype(poly))

    @inbounds for i in 1:length(poly)-1
        p = poly[i]
        n = poly[i+1]
        k = p[1]*n[2]-n[1]*p[2]
        a += k
        c = c .+ (p.+n).*k
    end
    a /= 2
    return c./(6*a)
end

# PolygonOps.jl

```@index
```

# `inpolygon`

```@docs
PolygonOps.inpolygon
PolygonOps.HaoSun
PolygonOps.HormannAgathos
```

## Examples

```
using PolygonOps
using StaticArrays

xv = [ 0.05840, 0.48375, 0.69356, 1.47478, 1.32158, 
        1.94545, 2.16477, 1.87639, 1.18218, 0.27615, 
        0.05840 ]
yv = [ 0.60628, 0.04728, 0.50000, 0.50000, 0.02015, 
        0.18161, 0.78850, 1.13589, 1.33781, 1.04650, 
        0.60628 ]

xa = 0:0.1:2.3
ya = 0:0.1:1.4

polygon = SVector.(xv,yv)
points = vec(SVector.(xa',ya))

inside = [inpolygon(p, polygon; in=true, on=false, out=false) for p in points]

using Plots
plot(Tuple.(polygon), legend=false)
scatter!(Tuple.(points), marker_z=inside)
```


# `PolygonOps.area`

```@docs
PolygonOps.area
```
